package com.muyu.system.controller;

import java.util.List;
import javax.servlet.http.HttpServletResponse;

import com.muyu.system.domain.resp.AsUserDeptNumResponse;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import com.muyu.common.log.annotation.Log;
import com.muyu.common.log.enums.BusinessType;
import com.muyu.common.security.annotation.RequiresPermissions;
import com.muyu.system.domain.AsUserDept;
import com.muyu.system.service.IAsUserDeptService;
import com.muyu.common.core.web.controller.BaseController;
import com.muyu.common.core.domain.Result;
import com.muyu.common.core.utils.poi.ExcelUtil;
import com.muyu.common.core.web.page.TableDataInfo;

/**
 * 【请填写功能名称】Controller
 *
 * @author muyu
 * @date 2024-04-14
 */
@RestController
@RequestMapping("/userDept")
public class AsUserDeptController extends BaseController
{

    @Autowired
    private IAsUserDeptService asUserDeptService;


    /**
     * 查询【请填写功能名称】列表
     */
    @RequiresPermissions("system:dept:list")
    @GetMapping("/list")
    public Result<TableDataInfo<AsUserDept>> list(AsUserDept asUserDept)
    {
        startPage();
        List<AsUserDept> list = asUserDeptService.selectAsUserDeptList(asUserDept);
        return getDataTable(list);
    }

    @GetMapping("/UpdateAsUserDept")
    public Result list(@RequestParam("id") Long id)
    {
        return asUserDeptService.updateAsUserDeptRead(id);
    }

    @GetMapping("/GetNum")
    public Result<AsUserDeptNumResponse> getNum(@RequestParam("noticeId") Long noticeId)
    {
        return asUserDeptService.getNum(noticeId);
    }

    /**
     * 导出【请填写功能名称】列表
     */
    @RequiresPermissions("system:dept:export")
    @Log(title = "【请填写功能名称】", businessType = BusinessType.EXPORT)
    @PostMapping("/export")
    public void export(HttpServletResponse response, AsUserDept asUserDept)
    {
        List<AsUserDept> list = asUserDeptService.selectAsUserDeptList(asUserDept);
        ExcelUtil<AsUserDept> util = new ExcelUtil<AsUserDept>(AsUserDept.class);
        util.exportExcel(response, list, "【请填写功能名称】数据");
    }

    /**
     * 获取【请填写功能名称】详细信息
     */
    @RequiresPermissions("system:dept:query")
    @GetMapping(value = "/{id}")
    public Result getInfo(@PathVariable("id") Long id)
    {
        return success(asUserDeptService.selectAsUserDeptById(id));
    }

    /**
     * 新增【请填写功能名称】
     */
    @RequiresPermissions("system:dept:add")
    @Log(title = "【请填写功能名称】", businessType = BusinessType.INSERT)
    @PostMapping
    public Result add(@RequestBody AsUserDept asUserDept)
    {
        return toAjax(asUserDeptService.insertAsUserDept(asUserDept));
    }

    /**
     * 修改【请填写功能名称】
     */
    @RequiresPermissions("system:dept:edit")
    @Log(title = "【请填写功能名称】", businessType = BusinessType.UPDATE)
    @PutMapping
    public Result edit(@RequestBody AsUserDept asUserDept)
    {
        return toAjax(asUserDeptService.updateAsUserDept(asUserDept));
    }

    /**
     * 删除【请填写功能名称】
     */
    @RequiresPermissions("system:dept:remove")
    @Log(title = "【请填写功能名称】", businessType = BusinessType.DELETE)
    @DeleteMapping("/{ids}")
    public Result remove(@PathVariable Long[] ids)
    {
        return toAjax(asUserDeptService.deleteAsUserDeptByIds(ids));
    }
}
